module.exports = function(grunt) {

	// Project configuration.
	grunt.initConfig({
		pkg: grunt.file.readJSON('package.json'),
		watch: {
			testHbs: {
				files: ['*.js', 'src/*.js'],
				tasks: ['mochaTest:hbs']
			},
			whenHelper: {
				files: ['test/specs/whenHelper.spec.js', 'src/helper/whenHelper.js'],
				tasks: ['mochaTest:whenHelper']
			}
		},
		mochaTest: {
			options: {
				require: 'expect.js',
				reporter: 'spec'
			},
			hbs: {
				src: ['test/specs/hbs.spec.js']
			},
			whenHelper: {
				src: ['test/specs/whenHelper.spec.js']
			}
		}
	});

	grunt.loadNpmTasks('grunt-contrib-watch');
	grunt.loadNpmTasks('grunt-mocha-test');

	grunt.registerTask('test', ['mochaTest']);
};