Handlebars.registerHelper('when', function(left, operator, right, options) {
	var compareFunc;

	var strToArray = function(str) {
		str = str.split(',');
		str = str.map(function(s) {
			return s.trim();
		});

		return str;
	};

	if (arguments.length !== 4 && arguments.length !== 2) {
		throw new Error('Handlebars when helper requires one or three parameters!');
	}

	if (arguments.length === 2) {
		expression = left;
		options = operator;
		compareFunc = function() {
			//jshint evil:true
			return eval(expression);
		}.bind(this);
	}
	else {
		switch(operator) {
			case 'eq':
			case '==':
				compareFunc = function() {
					return left == right;
				};
				break;

			case '===':
				compareFunc = function() {
					return left === right;
				};
				break;

			case 'lt':
			case '<':
				compareFunc = function() {
					return left < right;
				};
				break;

			case 'gt':
			case '>':
				compareFunc = function() {
					return left > right;
				};
				break;
				
			case 'lte':
			case '<=':
				compareFunc = function() {
					return left <= right;
				};
				break;
				
			case 'gte':
			case '>=':
				compareFunc = function() {
					return left >= right;
				};
				break;
				
			case 'not':
			case '!=':
				compareFunc = function() {
					return left != right;
				};
				break;
				
			case '!==':
				compareFunc = function() {
					return left !== right;
				};
				break;
				
			case 'in':
				compareFunc = function() {
					right = strToArray(right);
					return right.indexOf(left) !== -1;
				};
				break;
				
			case 'notin':
				compareFunc = function() {
					right = strToArray(right);
					return right.indexOf(left) === -1;
				};
				break;
		}
	}

	if (compareFunc()) {
		return options.fn(this);
	}
	else {
		return options.inverse(this);
	}
});