var expect = require('expect.js'),
	exec = require('child_process').exec,
	fs = require('fs'),
	path = require('path'),
	phantom = require('node-phantom');

describe('ComponentBuilderHBS', function() {
	beforeEach(function() {
		
	});

	afterEach(function() {

	});

	it('Should parse a Handlebars Template', function(done) {
		var options = {
			cwd: 'test/fixtures/test1/'
		};

		exec('component build --use ../../../node_modules/component-builder-hbs ', options, function(err, stdout, stderr) {
			// console.log('stdout: ' + stdout);
			// console.log('stderr: ' + stderr);
			if (err !== null) {
				// console.log('exec err: ' + err);
			}

			var file = fs.readFileSync('test/fixtures/test1/build/build.js', 'utf8');
			expect(file).to.contain('require.register("test1/template.hbs"');
			expect(file).to.contain('<h1 class=\\"hbs-test1\\">Hello');
			done();
			/*var url = 'file://' + path.join(__dirname, '../', 'fixtures/test1/test.html');
			console.log('TestURL:', url);
			var page = phantom.create(function(err, ph) {
				ph.createPage(function(err, page) {
					page.open('test/fixtures/test1/test.html', function() {
						console.log('Status', status);
						done();
						ph.exit();
					});
				});
			});*/

		});
	});

	it('Should parse a Handlebars Template', function(done) {
		var options = {
			cwd: 'test/fixtures/test2/'
		};

		exec('export HBS_LANG=de && component build --use ../../../node_modules/component-builder-hbs ', options, function(err, stdout, stderr) {
			// console.log('stdout: ' + stdout);
			// console.log('stderr: ' + stderr);
			if (err !== null) {
				console.log('exec err: ' + err);
			}

			var file = fs.readFileSync('test/fixtures/test2/build/build.js', 'utf8');
			expect(file).to.contain('require.register("test2/template.hbs"');
			expect(file).to.contain('<h1 class=\\"hbs-test2\\">');
			expect(file).to.contain('var __hbsLang = {"greeding":"Hallo"');
			done();
		});
	});

	it('Should add Handlebars helper', function() {
		var file = fs.readFileSync('test/fixtures/test2/build/build.js', 'utf8');
		expect(file).to.contain('Handlebars.registerHelper(\'when\'');
	});

	it('Should add custom Handlebars helper', function() {
		var file = fs.readFileSync('test/fixtures/test2/build/build.js', 'utf8');
		expect(file).to.contain('Handlebars.registerHelper(\'test\'');
	});
});