var Handlebars = require('handlebars'),
	expect = require('expect.js'),
	fs = require('fs');

describe('Handlebars when helper', function() {
	before(function() {
		//jshint evil: true
		var helper = fs.readFileSync('src/helper/whenHelper.js', 'utf8');
		eval(helper);
	});

	afterEach(function() {

	});

	it('Should make a == comparsion', function() {
		var tmpl = '{{#when a "==" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'y'
		});

		expect(result).to.eql('OK');

		var result = Handlebars.compile(tmpl)({
			a: '1',
			b: 1
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a == comparsion', function() {
		var tmpl = '{{#when a "==" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'n'
		});

		expect(result).to.eql('Fail');
	});

	it('Should make a eq comparsion', function() {
		var tmpl = '{{#when a "eq" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'y'
		});

		expect(result).to.eql('OK');

		var result = Handlebars.compile(tmpl)({
			a: '1',
			b: 1
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a eq comparsion', function() {
		var tmpl = '{{#when a "eq" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'n'
		});

		expect(result).to.eql('Fail');
	});

	it('Should make a === comparsion', function() {
		var tmpl = '{{#when a "===" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'y'
		});

		expect(result).to.eql('OK');

		var result = Handlebars.compile(tmpl)({
			a: '1',
			b: 1
		});

		expect(result).to.eql('Fail');
	});

	it('Should fail a === comparsion', function() {
		var tmpl = '{{#when a "===" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'n'
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a lt comparsion', function() {
		var tmpl = '{{#when a "lt" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 3
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '1',
			b: 2
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a lt comparsion', function() {
		var tmpl = '{{#when a "lt" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 1
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a < comparsion', function() {
		var tmpl = '{{#when a "<" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 3
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '1',
			b: 2
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a < comparsion', function() {
		var tmpl = '{{#when a "<" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 1
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a gt comparsion', function() {
		var tmpl = '{{#when a "gt" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 4,
			b: 3
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '4',
			b: 2
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a gt comparsion', function() {
		var tmpl = '{{#when a "gt" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 4
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a > comparsion', function() {
		var tmpl = '{{#when a ">" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 4,
			b: 3
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '4',
			b: 2
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a > comparsion', function() {
		var tmpl = '{{#when a ">" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 4
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a lte comparsion', function() {
		var tmpl = '{{#when a "lte" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 3
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '1',
			b: 2
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '2',
			b: 2
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a lte comparsion', function() {
		var tmpl = '{{#when a "lte" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 1
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a <= comparsion', function() {
		var tmpl = '{{#when a "<=" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 3
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '1',
			b: 2
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '2',
			b: 2
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a <= comparsion', function() {
		var tmpl = '{{#when a "<=" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 1
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a gte comparsion', function() {
		var tmpl = '{{#when a "gte" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 4,
			b: 3
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '4',
			b: 2
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '2',
			b: 2
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a gte comparsion', function() {
		var tmpl = '{{#when a "gte" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 4
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a >= comparsion', function() {
		var tmpl = '{{#when a ">=" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 4,
			b: 3
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '4',
			b: 2
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '2',
			b: 2
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a >= comparsion', function() {
		var tmpl = '{{#when a ">=" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 2,
			b: 4
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a not comparsion', function() {
		var tmpl = '{{#when a "not" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'x',
			b: 'y'
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '2',
			b: 1
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a not comparsion', function() {
		var tmpl = '{{#when a "not" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'y'
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a != comparsion', function() {
		var tmpl = '{{#when a "!=" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'x',
			b: 'y'
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '2',
			b: 1
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a != comparsion', function() {
		var tmpl = '{{#when a "!=" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'y'
		});

		expect(result).to.eql('Fail');
	});


	it('Should make a !== comparsion', function() {
		var tmpl = '{{#when a "!==" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'x',
			b: 'y'
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '2',
			b: 1
		});

		expect(result).to.eql('OK');

		result = Handlebars.compile(tmpl)({
			a: '1',
			b: 1
		});

		expect(result).to.eql('OK');
	});

	it('Should fail a !== comparsion', function() {
		var tmpl = '{{#when a "!==" b}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'y'
		});

		expect(result).to.eql('Fail');

		result = Handlebars.compile(tmpl)({
			a: '1',
			b: 1
		});

		expect(result).to.eql('OK');
	});

	it('Should make a jsexpression comparsion', function() {
		var tmpl = '{{#when "this.a == this.b && this.a != this.c"}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'y',
			c: 'z'
		});

		expect(result).to.eql('OK');
	});

	it('Should make a in comparsion', function() {
		var tmpl = '{{#when a "in" "x, y, z"}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'y',
			c: 'z'
		});

		expect(result).to.eql('OK');
	});

	it('Should make a notin comparsion', function() {
		var tmpl = '{{#when d "notin" "a, b, c"}}OK{{else}}Fail{{/when}}';
		var result = Handlebars.compile(tmpl)({
			a: 'y',
			b: 'y',
			c: 'z'
		});

		expect(result).to.eql('OK');
	});
});